Hi, Netter,
    I got some problems when I use ART2 neural net in pattern recognition.
May you can help me. Here is my problem ,the sorce code(in Turbo C++) of 
my program and the data file.

Q: When I use this program to recognize 26 patterns, the program will stop
   after 7 training cycle(i.e. feed the data into the program 7 times, and
   the program converge). But, when I use a large data file (5400 patterns)
   the program never stop(I run this program in a Intel 486DX2-66 PC for more 
   than 24 hours). What wrong with my program? Please help me. Please.

                                                Steve Liou
                                                yankunl@tpts1.seed.net.tw

/* --------------------- ART2 ------------------------*/
// Reference : Gail A. Carpenter and Stephen Grossberg,
//             " ART2: self-organization of stable category
//               recognition codes for analog input patterns",
//              APPLIED OPTICS, Vol.26, No.23, Dec. 1987
//
// topology of the network --- Fig.10 in Ref.

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <conio.h>

#define MaxPattern 30000
#define vect(x, i) (*(x+i))
		// ith data of vector x
#define TD(i, j) (*(TopDown + (i*InNodeNum + j)))
		// node i of F2 to node j of p of F1
#define BU(i, j) (*(BottomUp + (i*OutNodeNum + j)))
		// node i of p of F1 to node j of F2
#define Data(i, j) (*(*(pattern+i)+j))
		// jth data of ith pattern
float *old_p, *old_w, *sum;
float huge *w0, huge *x0, huge *v0, huge *u0, huge *r;
float huge *w, huge *x, huge *v, huge *u, huge *q, huge *p;
float huge *TopDown, huge *BottomUp, huge **pattern;
// dimensions of matrix TopDown are OutNodeNum x InNodeNum
// dimensions of matrix ButtomUp are InNodeNum x OutNodeNum
float tho, theta, beta=0.2, a=5.0, b=5.0, c=0.225, d=0.8;
unsigned long InNodeNum, OutNodeNum, TotalPattern, missed, huge *trace, changed;
	// trace -- to keep an eye on what pattern be recognizied into what category
long F2_on = -1;
	// which node in F2 is active, -1 means F2 is inactive
unsigned int rsnc=0, huge *OffNode, recall=0;

float L2_Norm(float huge *vector, unsigned long dim)
{
	unsigned long i;
	float tmp=0;
	for (i=0; i<dim; i++)
		tmp = tmp + vect(vector, i) * vect(vector, i);
	tmp = tmp > 0.001 ? tmp : 1;
	return sqrt(tmp);
}

// allocate memory 
int init_vector(unsigned int In, unsigned int Out)
{
	unsigned long i, j;

	//fprintf(stderr, "\n\tInitialize memory for vectors.");
	old_w = (float *)malloc(sizeof(float) * InNodeNum);
	old_p = (float *)malloc(sizeof(float) * InNodeNum);
		if ((!old_w) || (!old_p)) return -9;
	sum = (float *)malloc(sizeof(float) * OutNodeNum);
		if (!sum) return -9;
	w0 = (float huge *)farmalloc(sizeof(float) * In);
		if (!w0) {return -9;}
	x0 = (float huge *)farmalloc(sizeof(float) * In);
		if (!x0) {return -9;}
	v0 = (float huge *)farmalloc(sizeof(float) * In);
		if (!v0) {return -9;}
	u0 = (float huge *)farmalloc(sizeof(float) * In);
		if (!u0) {return -9;}
	for (i=0; i<In; i++) vect(u0, i) = 0.0;
	r = (float huge *)farmalloc(sizeof(float) * In);
		if (!r) return -9;
	w = (float huge *)farmalloc(sizeof(float) * In);
		if (!w) return -9;
	x = (float huge *)farmalloc(sizeof(float) * In);
		if (!x) return -9;
	v = (float huge *)farmalloc(sizeof(float) * In);
		if (!v) return -9;
	u = (float huge *)farmalloc(sizeof(float) * In);
		if (!u) return -9;
	for (i=0; i<In; i++) vect(u, i) = 0.0;
	q = (float huge *)farmalloc(sizeof(float) * In);
		if (!q) return -9;
	p = (float huge *)farmalloc(sizeof(float) * In);
		if (!p) return -9;
	OffNode = (unsigned int huge *)farmalloc(sizeof(unsigned int) * Out);
		if (!OffNode) return -9;
	for (i=0; i<Out; i++, vect(OffNode, i) = 0);
	TopDown = (float huge *)farmalloc(sizeof(float) * In * Out);
		if (!TopDown) return -9;
	// the initial value of TopDown weights are zero
	for (i=0; i<Out; i++)
		for (j=0; j<In; j++)
			TD(i, j) = 0.0;
	BottomUp = (float huge *)farmalloc(sizeof(float) * In * Out);
		if (!BottomUp) return -9;
	// the initial values of BottomUp weights must
	// be smaller then 1/((1-d)*sqrt(InNodeNum)
	for (i=0; i<In; i++)
		for (j=0; j<Out; j++)
			BU(i, j) = 1.0 / ((1.0 - d) * sqrt(In));
	pattern = (float huge **)farmalloc(sizeof(float huge *) * MaxPattern);
		if (!pattern) return -9;
	//fprintf(stderr, " .... done.");
	return 0;
}

int ReadDataFile(char *filename)
{
	FILE *FileHandle;
	unsigned long i, j;
	float ftmp;

	fprintf(stderr, "\nReading data file.");
	FileHandle = fopen(filename, "r");
		if (!FileHandle) {return -1;}
	fscanf(FileHandle, "%u\n", &InNodeNum);
		if (!InNodeNum) {return -2;}
	fscanf(FileHandle, "%u\n", &OutNodeNum);
		if (!OutNodeNum) {return -3;}
	fscanf(FileHandle, "%f\n", &theta);
	fscanf(FileHandle, "%f\n", &tho);
	i = init_vector(InNodeNum, OutNodeNum);
	if (i) { fclose(FileHandle); return i;}
	i = 0;
	fprintf(stderr, "\n\tReading patterns");
	while (!feof(FileHandle)) {
		fprintf(stdout, "\0x10\t\t %lu", i);
		*(pattern+i) = (float huge *)farmalloc(sizeof(float) * (InNodeNum+1));
			if (!(*(pattern+i))) { fclose(FileHandle); return -9;}
		for (j=0; j<(InNodeNum+1); j++)
			fscanf(FileHandle, "%f", &Data(i, j));
		if (++i>MaxPattern) return -4;
	}
	fprintf(stderr, " ... done.");
	TotalPattern = i - 1;
	trace = (unsigned long *)farmalloc(sizeof(unsigned long) * TotalPattern);
		if (!trace) return -9;
	for (i=0; i<TotalPattern; i++)
		vect(trace, i) = -1;
	return 0;
}

int F0_cycle(unsigned long loop)
{
	unsigned long i;
	float ftmp1, diff=99.0;

	//fprintf(stderr, "\nF0 cycle for pattern #%lu", loop);
	while (diff > 0.01) {
		for (i=0; i<InNodeNum; i++)
			vect(old_w, i) = vect(w0, i);
		for (i=0; i<InNodeNum; i++)
			vect(w0, i) = Data(loop, i) + a * vect(u0, i);
		ftmp1 = L2_Norm(w0, InNodeNum);
		for (i=0; i<InNodeNum; i++)
			vect(x0, i) = vect(w0, i) / ftmp1;
		for (i=0; i<InNodeNum; i++)
			vect(v0, i) = (vect(x0, i) > theta ? vect(x0, i) : 0);
		for (i=0; i<InNodeNum; i++)
			vect(u0, i) = vect(v0, i) / L2_Norm(v0, InNodeNum);
		diff = 0.0;
		for (i=0; i<InNodeNum; i++)
			diff += fabs(vect(old_w, i) - vect(w0, i));
	}
	//fprintf(stderr, "... done. ");
	for(i=0; i<InNodeNum; i++)		// initialize some vectors in F1 layer
		vect(w, i) = vect(p, i) = vect(u, i) = vect(u0, i);
	return 0;
}

float learn(unsigned long loop);
int F2_reset(void);
int F2_choose(unsigned long loop);

int F1_cycle(unsigned long loop)
{
	unsigned long i;
	float w_diff=1.0, p_diff=1.0, z_diff=1.0, tmp, wtmp, ptmp;
	int er;

	fprintf(stdout, "\nF1 cycle for pattern #%lu", loop);
	while ((w_diff > 0.01) || (p_diff > 0.01) || (z_diff > 0.01) || (beta < .9)) {
		for (i=0; i<InNodeNum; i++) {
			vect(old_w, i) = vect(w, i);
			vect(old_p, i) = vect(p, i);
			vect(w, i) = vect(u0, i) + a * vect(u, i);
			tmp = (F2_on < 0 ? 0.0 : d * TD(F2_on, i));
			vect(p, i) = vect(u, i) + tmp;
		}
		wtmp = L2_Norm(w, InNodeNum);
		ptmp = L2_Norm(p, InNodeNum);
		w_diff = p_diff = 0.0;
		for (i=0; i<InNodeNum; i++) {
			w_diff += fabs(vect(w, i) - vect(old_w, i));
			p_diff += fabs(vect(p, i) - vect(old_p, i));
			vect(x, i) = vect(w, i) / wtmp;
			vect(q, i) = vect(p, i) / ptmp;
		}
		for (i=0; i<InNodeNum; i++) {
			wtmp = vect(x, i) > theta ? vect(x, i) : 0;
			ptmp = vect(q, i) > theta ? vect(q, i) : 0;
			vect(v, i) = wtmp + b * ptmp;
		}
		tmp = L2_Norm(v, InNodeNum);
		for (i=0; i<InNodeNum; i++)
			vect(u, i) = vect(v, i) / tmp;
		if (!rsnc) {
			er = F2_choose(loop);
			if (er) return er;
		}
		ptmp = L2_Norm(p, InNodeNum);
		wtmp = L2_Norm(u0, InNodeNum);
		for (i=0; i<InNodeNum; i++)
			vect(r, i) = (vect(u0, i) + c * vect(p, i)) / (wtmp + c * ptmp);
		tmp = L2_Norm(r, InNodeNum);
		if (tmp < tho) F2_reset(); else
			if (F2_on > -1) z_diff = learn(loop);
		if (missed >= OutNodeNum) {
			F2_on = -1;
			break;
		}
	}	// end of while
	if (F2_on > -1) {
		if (vect(trace, loop) != F2_on) {vect(trace, loop) = F2_on; changed++;}
        // if the recoginized category is not the same as the category in last training
        // cycle for this pattern, changed = changed + 1
        // And, the program will not stop untill 'changed' keeps zero for the whole 
        // training cycle.

		fprintf(stdout, " -> Category %lu",  F2_on);
	} else
		fprintf(stdout, " -> Failed");
	rsnc = 0;
	return 0;
}

int F2_choose(unsigned long loop)
{
	unsigned long i, j;
	float tmp=0.0;

	missed++;
	for(i=0; i<OutNodeNum; i++) {
		vect(sum, i) = 0.0;
		if (!vect(OffNode, i))
			for (j=0; j<InNodeNum; j++)
				vect(sum, i) += vect(p, j) * BU(j, i);
		tmp = (tmp < vect(sum, i) ? vect(sum, i) : tmp);
	}
	if (tmp == 0.0) { F2_on = -1; return 0;}
	for (i=0; i<OutNodeNum && vect(sum, i)<tmp; i++);
	F2_on = i;
	rsnc = 1;
	return 0;
}

float learn(unsigned long loop)
{
	unsigned long i;
	float tmp1=0.0, tmp2=0.0;

	if (recall) return 0;
	for (i=0; i<InNodeNum; i++) {
		tmp1 += fabs(d * (vect(p, i) - TD(F2_on, i)));
		tmp2 += fabs(d * (vect(p, i) - BU(i, F2_on)));
		TD(F2_on, i) += d * (vect(p, i) - TD(F2_on, i));
		BU(i, F2_on) += d * (vect(p, i) - BU(i, F2_on));
	}
	return tmp1+tmp2;
}

int F2_reset(void)
{
	unsigned long i, j;

	if (F2_on > -1) {
		vect(OffNode, F2_on) = -1;
	}
	rsnc = 0;
	F2_on = -1;

	// reset F1 when F2 is reset
	// But, if I don't do this, it seems doesn't matter.
	for (i=0; i<InNodeNum; i++)
		vect(p, i) = vect(u, i) = vect(u0, i);

	return 0;
}

// initialize values for a new pattern that will be trained
int init_NewPattern(void)
{
	unsigned long i;

	for (i=0; i<InNodeNum; i++)
		vect(p, i) = vect(u, i) = vect(u0, i) = vect(w0, i) = 0.0;
	for (i=0; i<OutNodeNum; i++) {
		vect(OffNode, i) = 0;
	}
	beta = 0.2;
	rsnc = 0;
	F2_on = -1;
	missed = -1;
	return 0;
}

void do_error(int i)
{
	if (!i) return;
	switch (i) {
		case -1 :
			fprintf(stderr, "\7\n Can't open data file.\n");
			exit(-1);
		case -2 :
			fprintf(stderr, "\7\n Data define error <InNodeNum>.\n");
			exit(-2);
		case -3 :
			fprintf(stderr, "\7\n Data define error <OutNodeNum>.\n");
			exit(-3);
		case -4 :
			fprintf(stderr, "\7\n Too many patterns(> %lu).\n", MaxPattern);
			exit(-4);
		case -9 :
			fprintf(stderr, "\7\n Out of Memory ...\n");
			exit(-9);
		default :
			fprintf(stderr, "\7\n Unknown error ...\n");
			exit(i);
	}
}

int main(void)
{
	char FileName[128];
	unsigned long i, j;
	float tmp;
	char c;
	FILE *out;

	fprintf(stderr, "\nInput data file name [art2.dat]: ");
	gets(FileName);
	if (FileName[0] == 0) strcpy(FileName, "art2.dat");
	do_error(ReadDataFile(FileName));
	fprintf(stderr, "\nRead weight value file (ENTER for none): ");
	gets(FileName);
	if (FileName[0]) {
		out = fopen(FileName, "r");
		if (out) {
			fscanf(out, "%lu\n", &i);
				if (i != InNodeNum)
					fprintf(stderr, "\n\t\tInvalid <InNodeNum> in %s.", FileName);
				else {
					fscanf(out, "%lu\n", &i);
					if (i != OutNodeNum)
						fprintf(stderr, "\n\t\tInvalid <OutNodeNum> in %s.", FileName);
					else {
						fscanf(out, "%f\n", &tmp);
						if (tmp != theta) {
							fprintf(stderr, "\n\t\t<theta> changed to %9.7f .", tmp);
							theta = tmp;
						}
						fscanf(out, "%f\n", &tmp);
						if (tmp != tho) {
							fprintf(stderr, "\n\t\t<tho> changed to %9.7f .", tmp);
								tho = tmp;
						}
						for (i=0;  i<InNodeNum; i++)
							for(j=0; j<OutNodeNum; j++)
								fscanf(out, "%f", &BU(i, j));
						for (i=0; i<OutNodeNum; i++)
							for (j=0; j<InNodeNum; j++)
								fscanf(out, "%f", &TD(i, j));
						fprintf(stderr, "\n\tPress '1' for learning with old weight.");
						gets(FileName);
						if (FileName[1]=='1') recall = 1; else recall = 0;
					}
				}
		}
	}

	i = j = 0;
	changed = 1;
    // training all patterns again and again 
    // untill no category of pattern is changed in a training cycle, i.e. changed = 0
	while (changed) {
		changed = 0; j++;
		for (i=0; i<TotalPattern; i++) {
			if (kbhit()) {
				c = getch();
				if (c==' ') {
					fprintf(stderr, "\n Loop %lu, %lu pattern changed.", j, changed);
					fprintf(stderr, "\n Press any key to continue.");
					getch();
				}
			}
			init_NewPattern();
			do_error(F0_cycle(i));
			do_error(F1_cycle(i));
		}
	}
	out = fopen("art2.out", "a");
	for (i=0; i<TotalPattern; i++) {
		for (j=0; j<(InNodeNum+1); j++)
			fprintf(out, "%15.9f  ", Data(i, j));
		fprintf(out, "%-10lu\n", vect(trace, i));
	}
	fclose(out);
	fprintf(stderr, "\nWeight value file name (ENTER for none): ");
	gets(FileName);
	if (FileName[0]) {
		out = fopen(FileName, "w");
		fprintf(out, "%lu\n%lu\n", InNodeNum, OutNodeNum);
		fprintf(out, "%9.7f\n%9.7f\n",theta, tho);
		for (i=0; i<InNodeNum; i++) {
			for (j=0; j<OutNodeNum; j++) fprintf(out, "%11.9f  ", BU(i, j));
			fprintf(out, "\n");
		}
		for (i=0; i<OutNodeNum; i++) {
			for (j=0; j<InNodeNum; j++) fprintf(out, "%11.9f  ", TD(i, j));
			fprintf(out, "\n");
		}
		fclose(out);
	}
	return 0;
}

// the end of ART2 source code

    Following is the data file "ART2.DAT", if you need the large data file, send
me a message.

16
3
.25
.8
0.094118 0.552941 1.000000 0.270588 0.352941 0.752941 0.870588 0.752941 0.988235 0.882353 0.847059 0.988235 0.776471 0.411765 0.200000 0.623529 1
0.794118 0.558824 0.539216 0.656863 0.882353 0.539216 0.872549 0.813725 1.000000 0.843137 0.892157 0.833333 0.882353 0.539216 0.509804 0.598039 2
0.769231 0.788462 0.788462 0.692308 1.000000 0.057692 0.000000 0.000000 0.980769 0.000000 0.000000 0.038462 0.903846 0.538462 0.500000 0.615385 3
0.745098 0.725490 0.539216 0.529412 0.637255 0.078431 0.029412 0.558824 0.656863 0.000000 0.147059 0.666667 1.000000 0.578431 0.578431 0.284314 4
0.807339 0.614679 0.614679 0.532110 1.000000 0.614679 0.477064 0.073394 0.954128 0.385321 0.266055 0.073394 0.990826 0.614679 0.614679 0.477064 5
0.760417 0.739583 0.697917 0.604167 1.000000 0.697917 0.614583 0.166667 0.895833 0.437500 0.354167 0.135417 0.541667 0.000000 0.000000 0.000000 6
0.556818 0.613636 0.625000 0.363636 0.750000 0.522727 0.625000 0.704545 0.772727 0.363636 0.602273 1.000000 0.431818 0.625000 0.863636 0.806818 7
0.467890 0.000000 0.000000 0.385321 0.954128 0.486239 0.486239 1.000000 0.816514 0.311927 0.311927 0.834862 0.458716 0.000000 0.000000 0.532110 8
0.242424 0.712121 1.000000 0.318182 0.000000 0.757576 0.590909 0.000000 0.000000 0.696970 0.303030 0.000000 0.166667 0.848485 0.257576 0.090909 9
0.054054 0.337838 1.000000 0.729730 0.000000 0.000000 0.716216 0.459459 0.094595 0.013514 0.675676 0.405405 0.581081 0.324324 0.540541 0.175676 10
0.553191 0.276596 0.468085 0.574468 0.882979 1.000000 0.776596 0.223404 1.000000 0.723404 0.617021 0.000000 0.510638 0.212766 0.595745 0.085106 11
0.591398 0.000000 0.000000 0.000000 0.698925 0.000000 0.000000 0.000000 0.698925 0.000000 0.000000 0.000000 1.000000 0.569892 0.569892 0.494624 12
0.902655 0.168142 0.469027 0.725664 1.000000 0.486726 0.557522 0.769912 0.725664 0.778761 0.672566 0.619469 0.495575 0.601770 0.557522 0.442478 13
0.920792 0.257426 0.000000 0.277228 0.782178 0.603960 0.178218 0.603960 0.603960 0.188119 0.584158 0.772277 0.534653 0.000000 0.188119 1.000000 14
0.762712 0.762712 0.745763 0.813559 0.915254 0.067797 0.033898 0.745763 1.000000 0.000000 0.000000 0.644068 0.915254 0.508475 0.457627 0.966102 15
0.881188 0.465347 0.465347 0.544554 0.851485 0.297030 0.297030 0.603960 1.000000 0.465347 0.465347 0.217822 0.554455 0.000000 0.000000 0.000000 16
0.500000 0.573770 0.336066 0.065574 0.409836 0.065574 0.434426 0.204918 0.598361 0.311475 0.590164 0.278689 0.877049 0.811475 1.000000 0.409836 17
0.780000 0.550000 0.550000 0.670000 0.810000 0.480000 0.660000 0.630000 1.000000 0.740000 0.880000 0.290000 0.570000 0.050000 0.310000 0.500000 18
0.640000 0.720000 0.706667 0.693333 0.920000 0.533333 0.226667 0.106667 0.466667 0.706667 0.706667 0.506667 0.760000 0.533333 0.693333 1.000000 19
0.478261 1.000000 0.808696 0.478261 0.000000 0.530435 0.330435 0.000000 0.000000 0.530435 0.330435 0.000000 0.000000 0.460870 0.260870 0.000000 20
0.847458 0.000000 0.000000 0.457627 1.000000 0.000000 0.000000 0.644068 0.949153 0.067797 0.000000 0.644068 0.661017 0.593220 0.372881 0.847458 21
0.480000 0.000000 0.110000 0.350000 0.610000 0.260000 0.420000 0.380000 0.540000 0.710000 0.610000 0.100000 0.240000 1.000000 0.350000 0.000000 22
0.482759 0.367816 0.275862 0.367816 0.540230 0.965517 0.620690 0.563218 0.724138 1.000000 0.908046 0.505747 0.712644 0.885057 0.770115 0.425287 23
0.436170 0.372340 0.319149 0.500000 0.095745 0.638298 1.000000 0.276596 0.159574 0.702128 0.702128 0.361702 0.446809 0.276596 0.127660 0.446809 24
0.735632 0.321839 0.229885 0.597701 0.310345 1.000000 0.942529 0.218391 0.011494 0.839080 0.839080 0.000000 0.000000 0.425287 0.712644 0.000000 25
0.343434 0.616162 0.777778 1.000000 0.000000 0.191919 0.585859 0.262626 0.191919 0.606061 0.272727 0.030303 0.919192 0.818182 0.616162 0.454545 26

